
# Simple tool to extract package list from xorg.modules file (see XMODURI) and create list of matching glob from g2 format repo.

: "${XMODBRANCH:="master"}"
: "${XMODURI:="https://gitlab.freedesktop.org/xorg/util/modular/raw/${XMODBRANCH}/xorg.modules"}"
: "${REPOROOT:="/var/git/phkg2/g2-source-repos/gentoo"}"

# Fetch the xorg.modules file to stdout
_fetch_xmod() {
	wget -q -O - "${XMODURI}"
}

# Extract values from '<branch checkoutdir="<value>" .../>' tags
_extract_checkouts() {
	sed -n -e '/<branch/,/\/>/ { s/.*\(checkoutdir="\)\([^"]*\)".*/\2/p; };' | sort -u
}

# Fix up returned list a bit for known mismatches
_filter_checkouts() {
	sed \
		-e 's|xorg/xserver|xorg/xorg-server|' \
		-e 's|xorgproto|xorg-proto|' \
		-e 's|xcb/proto|&/xcb-proto|' \
		-e 's|pthread-stubs|lib&|' \
		-e 's|font/util|&/font-util|' \
		-e 's|util/macros|&/util/util-macros|' \
		-e 's|data/bitmaps|data/xbitmaps|' \
		-e 's|xorg/font/|xorg/font/font-|' \
		-e 's|font/font-encodings|font/encodings|' \
		-e 's|libXfont|libXfont2|' \
		-e 's|libXRes|libXres|' \
		-e 's|libxtrans|xtrans|' \
		-e 's|drm|libdrm|' \
		-e 's|libxcb-util|xcb-util|' \
		-e 's|libxcb-render-util|xcb-util-renderutil|' \
		-e 's|libxcb-|xcb-util-|' \
		-e 's|xcbproto|xcb-proto|' \
		-e '/^$/ d'
}

# Filter out or fixup various catpkgs
# remove mesa, as it's tracked on it's own.
_filter_catpkgs() {
	sed \
		-e 's|media-libs/mesa||' \
		-e '/^$/ d'
}

# Fetch the file and run through checkout filters.
_get_checkouts_raw() {
	_fetch_xmod | _extract_checkouts
}

# Fetch the file and run through checkout filters.
_get_checkouts() {
	_get_checkouts_raw | _filter_checkouts
}

# Find directories of the form *-*/* in the REPOROOT matching the list of names returned by _get_checkouts.
_match_checkouts_in_src_repo() {
	for pkg in $( _get_checkouts ) ; do
		local myfile="$(echo "${REPOROOT}"/*-*/${pkg##*/})"
		if [ "${myfile#${REPOROOT}}" == '/*-*/'"${pkg##*/}" ] ; then
			printf -- '# No catpkg matching %s.\n' "'${pkg}'"
		else
			echo "${myfile}"
		fi
	done
}

# Extract the catpkg from a full repo path.
_make_catpkgs_from_repopaths() {
	sed -e 's|^\(/.*/\)\([^/]\+/\)\([^/]\+\)|\2\3|p' | sort -u
}

# Make list of all matching catpkgs in the repo.
_get_catpkgs() {
	_match_checkouts_in_src_repo | _make_catpkgs_from_repopaths | _filter_catpkgs
}

# Add the ./ prefilx and /* suffix to make a glob from a catpkg for use by git.
_make_globs_from_catpkgs() {
	sed -e 's|^[-_[:alnum:]]\+/.*$|./&/*|'
}

# Make a list of all globs for all matching catpkgs in the repo
_get_catpkgs_globs() {
	_get_catpkgs | _make_globs_from_catpkgs
}

# Print help
_help() {
	printf '\nUsage: %s [Option]' "$0"
	printf '\n  Options:'
	printf '\n\t--checkouts-raw: Get raw checkout list.'
	printf '\n\t--checkouts: Get filtered checkout list.'
	printf '\n\t--catpkgs: Get catpkgs list.'
	printf '\n\t--globs: Get globs list.'
	printf '\n  No arguments: --globs.\n\n'
}

# Parse our command line
if [ "${1}" == "--help" ] ; then
	_help
	exit 0
elif [ "${1}" == "--checkouts-raw" ] ; then
	shift
	mycmd="_get_checkouts_raw"
elif [ "${1}" == "--checkouts" ] ; then
	shift
	mycmd="_get_checkouts"
elif [ "${1}" == "--catpkgs" ] ; then
	shift
	mycmd="_get_catpkgs"
elif [ "${1}" == "--globs" ] ; then
	mycmd="_get_catpkgs_globs"
	shift
elif [ $# -gt 0 ] ; then
	_help
	exit 1
else
	mycmd="_get_catpkgs_globs"
fi

# Loop over out list of repos and fetch the globs for each
for r in ${@:-${REPOROOT}} ; do
	REPOROOT="${r}"
	#_fetch_xmod | _extract_checkouts
	#_match_catpkgs_in_src_repo
	printf -- '\n##\n# Autogenerated\n##\n'
	${mycmd}
done
